
START_LEVEL=1

PENTAGON=1

/*



(+) телепорт наверх уровня - синий с квадратом внутри и y=8 когда внутрь его залетаешь
    сверху такой же из него вылетаешь
    герои и враги


(-) в меню висит в нирване большой спрайт йаззи синий-голубой гига!!
(-) крыша дома оформить
(+) звуки появления уровня

(+) шипы вверх 
(+) мины, наступил - активируется и взрыв через несколько тиков по звукам minesList
(+) мостики - игра или игрок на паузе и рисуется чисто мостик
(+) рамка неубиваемая
(+) баг - одно знакоместо не рисуется!
(+) переделать взрыв мины


Герой:
(-) wasKeyUp для спрыгивания
(+) спрыгнуть с моста
(+) смерть на шипах и в огне
(+) баг с падением на лестницу


Враги:
(+) если лестница и снизу и сверху то рандомно 
(+) пока мигает - не убивать героя
(+) задержка старта - мигают висят в воздухе
(+) смерть на огне и шипах - респаун на точку старта
(+) режим атаки когда герой на линии видимости
(+) баг в ямке
(+) убивают героя
(+) враг может включать мост тоже ;)
(+) баг когда они вниз лезут c лестницы
(+) баг с падением на лестницу
(+) баг когда пол в одном знакометсе и спрыгиваем с лестницы

ИДЕИ В УРОВНИ:

Обучение, закрыт в комнате берем кирку и мины разбивают к золоту путь (!)
За миной лежит золото нужно успеть иначе обратно в огонь упасть
Фишка со спрыгиванием с мостов, посередине мосты в воздухе золото
Мост над пропастью включают враги
ЗАМУРОВАННЫЕ МИНЫ

*/


;gameplay states
GS_GAMEPLAY=0
GS_SHOWLEVEL=1
GS_BRIDGE=2
GS_FADEOUT=3
GS_STAGECLEAR=4
GS_DEAD=5

//include variables and macros
	include "include\vars.a80"
	include "include\macrs.a80"

	device zxspectrum128

	org 16384
	incbin "gfx\yazzie.scr"

	page 0
	org 24500
start:
	;call getScreenAddr		
	di	
	ld sp,24499 : 	xor a : out (254),a 	

	;detects pentagon and reset or continue based on results and hardware
	call detectPentagon	

	ld bc,#7ffd : ld a,16+1 : out (c),a
	call 49152;init menu music
	ld bc,#7ffd : ld a,16+0 : out (c),a
	ld hl,interruptMenu :	call IMON: ei


	call kempstonTest : ei

	;pause to show picture
	ld b,125
1:
	halt
	djnz 1b




	call fadeOut
	ld hl,menuPacked : ld de,16384 : call DEC40
	ld bc,menuText :  call drawString
	ld bc,menuText2 :  call drawString
	ld bc,menuText3 :  call drawString
	;ld bc,menuText4 :  call drawString

	;MAIN MENU
1:
	halt
	call drawPushFire
	call checkFireButton
	jr nz,1b
	ld hl,49152+7 : ld (menuSoundFrame+1),hl
	halt
	call initSound
	ld a,13 : call AFXPLAY3 : ld a,16+3 : ld (mPage+1),a
	ld hl,soundFrame : ld (menuSoundFrame+1),hl
	halt

	call fadeOut

	ld b,80
1:
	halt
	djnz 1b

	di

	;xor a : out (254),a : halt

	call initGame	
    ;patch tiles based on level num
	ld ix,tilesAddr+1 : ld (ix),high tiles
	ld a,(currentLevel)
	cp 11
	jr c,1f
	cp 16
	jr nc,2f
	ld (ix),high tiles01
	jr 1f
2:
	ld (ix),high tiles02
1:
	call showBorder	
    ;SETUP INTERRUPTS
	ld hl,interrupt :	call IMON: ei	
	call updateStatusBar
	call resetLevel
	jp mainLoop

	include "maps\maps.a80"
menuPacked: incbin "gfx\menu.scr.mlz"

//Table how to show cells
showFX:	incbin  "include\fx.bin"
		db 0,0
	db 255

//include string and font
	include "include\strings.a80"

gameState: db GS_FADEOUT

	//include interrupts procs
	include "include/interrupts.a80"
	//include system procs
	include "include/system.a80"

    display /d,"pre 32768: ",$
        

	org 32768
;dubGold:	db	00000
mainLoop:
	halt

	ld a,(gameState)
	cp GS_GAMEPLAY
	jp z,doGamePlay

	cp GS_BRIDGE
	jp z,doBridge

	cp GS_SHOWLEVEL
	jp z,doShowLevel

	cp GS_FADEOUT
	jp z,doFadeout

	cp GS_STAGECLEAR
	jp z,doStageClear

	cp GS_DEAD
	jp z,doStageDead

	jp mainLoop

doStageDead:
	ld a,75 : dec a : ld (doStageDead+1),a
	or a
	jr z,1f

	push af : 	call doEnemies : pop af

	cp 73
	jp nz,mainLoop
	ld a,14 : call AFXPLAY3		
	jp mainLoop
1:
	ld a,75 : ld (doStageDead+1),a
	call restartLevel
	jp mainLoop

doStageClear:
	ld a,75 : dec a : ld (doStageClear+1),a
	or a
	jr z,1f

	push af
	call doHero
	call doEnemies
	pop af

	cp 73
	jp nz,mainLoop
	ld a,13 : call AFXPLAY3		
	jp mainLoop
1:
	ld a,75 : ld (doStageClear+1),a
	call nextLevel
	jp mainLoop

nextLevel:
	 ;halt
	 ;patch tiles based on level num
	ld ix,tilesAddr+1 : ld (ix),high tiles
	ld a,(currentLevel)
	cp 10
	jr c,1f
	cp 15
	jr nc,2f
	ld (ix),high tiles01
	jr 1f
2:
	ld (ix),high tiles02
1:
	 call showBorder
	 halt
	 ld a,(currentLevel) : inc a : ld (currentLevel),a
	 call muteMusic
	 call resetLevel	 
	 ld a,GS_FADEOUT : ld (gameState),a		 	  
	ret

restartLevel:
	 halt	 
	 call muteMusic
	 call resetLevel	 
	 ld a,GS_FADEOUT : ld (gameState),a		  
	ret

doFadeout:
	dup 24 
		call fadeLevel 
		;ld a,(gameState) : cp GS_FADEOUT : jp nz,mainLoop
	edup	

dpd0: ld a,1
	 inc a 
	 and 1
	 ld (dpd0+1),a
		or a
		call z,playMostSound
	jp mainLoop	

doShowLevel:
	dup 16 : call showLevel : edup	

dpd: ld a,1
	 inc a 
	 and 3
	 ld (dpd+1),a
		or a
		call z,playMostSound
	
	
	jp mainLoop

updateStatusBar:	
	ld a,(currentLevel) : add a,a : ld c,a : ld b,0 : ld hl,levelsText : add hl,bc
	ld de,statusText+10 : ldi:ldi
	ld bc,statusText
	call drawText
	ret

doDelayedOutro:
	ld a,0 : inc a : ld ($-2),a
	or a : ret nz
doOutro:	
	ld bc,outro4
	push bc
	call drawString
	pop hl : ld bc,30: add hl,bc
	ld a,(hl)
	cp 254
	jr nz,1f
	ld hl,outro4
1:
	ld (doOutro+1),hl
	
	;call playMostSound

	ret

doGamePlay:	
;======== HERO PART ===============
	;ld a,0 : out (254),a
	;ld a,1 : out (254),a
	call doHero
	;ld a,2 : out (254),a
	call doEnemies
	;ld a,0 : out (254),a
;======== ENEMIES PART ============

	ld a,(currentLevel)
	cp 21
	call z,doDelayedOutro

;      ;R
      ld bc,64510
      in a,(c)
      BIT 3,A
      jp nz,1f
	  halt
	  call muteMusic
	  call resetLevel
	  ld a,GS_FADEOUT : ld (gameState),a	
	  jp mainLoop
1:	  
	  ld bc,64510
      in a,(c)      
      BIT 4,A
      jp nz,1f
	  BIT 2,A
	  call z,nextLevel
1:  

    jp mainLoop

//include hero proces
	include "include\hero.a80"
//include controls proces
	include "include\controls.a80"
//include levels proces
	include "include/level.a80"
//include game interrupt
	include "include/interrupt.a80"
//include nirvana functions
	include "include/nirvana.a80"
//include bridge functions
	include "include\bridge.a80"
//include sfx player
	include "include\sound.a80"
	//include "include\soundPT3.a80"
	//include help proces
		include "include\procs.a80"


 display /d,"pre 49152: ",$

	org 49152

//include tiles
	align 256
tiles:	include "gfx\tiles.asm"
	align 256
tiles01:		include "gfx\tiles01.asm"
	align 256
tiles02:		include "gfx\tiles02.asm"
//include enemies logic
	include "include/enemy.a80"
//include mines
	include "include\mines.a80"
//include game gfx
	include "include\gfx.a80"
//include sprites lib
	include "include\sprites.a80"


//include depacker
	include "include\unmegalz_fast_v2.asm"

font: 
    incbin "gfx\font.fnt"

	align 256
rndX: incbin "include\rndX.bin"

fadeOut:
halt
        LD B,7
L0:      LD C,4
L1:      HALT
	DEC C
	JR NZ,L1
	LD HL,23295
L2:      LD A,(HL)
	AND 56
	JR Z,L3
	SUB 8
L3:      LD C,A
	LD A,(HL)
	AND 7
	JR Z,L4
	DEC A
L4:      OR C
	LD (HL),A
	DEC HL
	BIT 3,H
	JR NZ,L2
	DJNZ L0

	ret


	display /d,"total: ",$

	page 3
	org 49152


	define AYREGS buffer ; TBKPSGPlayer.BufferPSG

SFXDATA:	incbin "sound/sfx.afb"
;PackedPSG:	incbin "sound/gameMusic1.psg.tpp"

music01:      incbin "sound\gameMusic1.psg.tpp"
music02:      incbin "sound\gameMusic2.psg.tpp"
music03:      incbin "sound\gameMusic4.psg.tpp"
music04:      incbin "sound\gameMusic3.psg.tpp"
music05:      incbin "sound\gameMusic5.psg.tpp"
music06:      incbin "sound\gameMusic6.psg.tpp"

ending:      incbin "sound\ending.psg.tpp"

nullMusic: incbin "sound\nullMusic.psg.tpp"


    include "include/tbkplayer.aligned.asm"
	include "include/afxTbk.asm"

buffer  ds 14, 0

    block 32,0

	page 1
	org 49152
menuMusic:      incbin "sound\menu.bin"

 	//IF ((_ERRORS = 0) && (_WARNINGS = 0))
	IF (_ERRORS = 0) 

		IF (PENTAGON=0)
    		savetap "yazzie128.tap",24500
			SHELLEXEC "yazzie128.tap"
		ELSE
			savetap "yazziePentagon.tap",24500
			SHELLEXEC "yazziePentagon.tap"
		ENDIF
    ENDIF
